<template>
  <div class="view-account">
    <div class="view-account-header"></div>
    <div class="view-account-container">
      <div class="view-account-top">
        <div class="view-account-top-logo">
          <img :src="websiteConfig.loginImage" alt="" />
        </div>
        <div class="view-account-top-desc">{{ websiteConfig.loginDesc }}</div>
      </div>
      <div class="view-account-form">
        <n-form
          ref="formRef"
          label-placement="left"
          size="large"
          :model="formInline"
          :rules="rules"
        >
          <n-form-item path="username">
            <n-input
              v-model:value="formInline.username"
              placeholder="请输入用户名"
            >
              <template #prefix>
                <n-icon size="18" color="#808695">
                  <PersonOutline />
                </n-icon>
              </template>
            </n-input>
          </n-form-item>
          <n-form-item path="password">
            <n-input
              v-model:value="formInline.password"
              type="password"
              showPasswordOn="click"
              placeholder="请输入密码"
            >
              <template #prefix>
                <n-icon size="18" color="#808695">
                  <LockClosedOutline />
                </n-icon>
              </template>
            </n-input>
          </n-form-item>

          <n-form-item>
            <n-button
              type="info"
              @click="handleSubmit"
              size="large"
              :loading="loading"
              block
            >
              登录
            </n-button>
          </n-form-item>
        </n-form>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { PersonOutline, LockClosedOutline } from "@vicons/ionicons5";
import { useUserStore } from "@/store/modules/user";
// import { routerTurnByName, cryptoEncode } from "@/utils";
// import { StorageEnum } from "@/enums/storageEnum";
import { ResultEnum } from "@/enums/httpEnum";
import { PageEnum } from "@/enums/pageEnum";
import { useRoute, useRouter } from "vue-router";
import { websiteConfig } from "@/config/website.config";
const userStore = useUserStore();
const router = useRouter();

const route = useRoute();

interface FormState {
  username: string;
  password: string;
}

const formRef = ref();
const loading = ref(false);

const formInline = reactive({
  username: "admin",
  password: "123456",
  isCaptcha: true,
});

const rules = {
  username: { required: true, message: "请输入用户名", trigger: "blur" },
  password: { required: true, message: "请输入密码", trigger: "blur" },
};

const handleSubmit = (e) => {
  e.preventDefault();
  formRef.value.validate(async (errors) => {
    if (!errors) {
      const { username, password } = formInline;
      window["$message"].loading("登录中...");
      loading.value = true;

      const params: FormState = {
        username,
        password,
      };

      try {
        const { status } = await userStore.login(params);
        window["$message"].destroyAll();
        if (status == ResultEnum.STATUS) {
          const toPath = decodeURIComponent(
            (route.query?.redirect || "/") as string
          );
          window["$message"].success("登录成功，即将进入系统");
          if (route.name === PageEnum.BASE_LOGIN_NAME) {
            router.replace("/");
          } else router.replace(toPath);
        } else {
          window["$message"].info("登录失败");
        }
      } finally {
        loading.value = false;
      }
    } else {
      window["$message"].error("请填写完整信息，并且进行验证码校验");
    }
  });
};
</script>

<style lang="scss" scoped>
.view-account {
  display: flex;
  flex-direction: column;
  height: 100vh;
  overflow: auto;

  &-container {
    flex: 1;
    min-width: 320px;
    max-width: 384px;
    padding: 32px 12px;
    margin: 0 auto;
  }

  &-top {
    padding: 32px 0;
    text-align: center;

    &-desc {
      font-size: 14px;
      color: #808695;
    }
  }

  &-other {
    width: 100%;
  }

  .default-color {
    color: #515a6e;

    .ant-checkbox-wrapper {
      color: #515a6e;
    }
  }
}

@media (width >= 768px) {
  .view-account {
    background-image: url("../../assets/images/login.svg");
    background-repeat: no-repeat;
    background-position: 50%;
    background-size: 100%;
  }

  .page-account-container {
    padding: 32px 0 24px;
  }
}
</style>
